﻿Imports System.IO

Public Class Form1
    Public DupesDb As DataTable, dtrRow As DataRow

    Private Sub CreateTable()
        If Not DupesDb Is Nothing Then DupesDb.Dispose()
        DupesDb = New DataTable
        DupesDb.Columns.Add("cThumb", GetType(Image))
        DupesDb.Columns.Add("cFileName", GetType(String))
        DupesDb.Columns.Add("cExt", GetType(String))
        DupesDb.Columns.Add("cSize", GetType(Double))
        DupesDb.Columns.Add("cDateTime", GetType(String))
        DupesDb.Columns.Add("cFullPath", GetType(String))
    End Sub

    Private Function CreateBoxImg(ByVal NewColor As Color, Optional ByVal ZeroSize As Int16 = 0) As Image
        Dim newBitmap As Bitmap, g As Graphics
        newBitmap = New Bitmap(16, 16, Imaging.PixelFormat.Format32bppArgb)
        g = Graphics.FromImage(newBitmap)
        If ZeroSize = 1 Then
            g.FillRectangle(New SolidBrush(NewColor), New Rectangle(0, 0, 0, 0))
        Else
            g.FillRectangle(New SolidBrush(NewColor), New Rectangle(0, 0, 16, 16))
        End If
        g.Dispose()
        g = Nothing
        Return newBitmap
    End Function

    Private Sub btn_Load_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_load.Click
        CreateTable()

        Dim CurDir As DirectoryInfo = New DirectoryInfo("C:\ImgTest\Images")
        Dim fileArray() As FileInfo = CurDir.GetFiles
        For Each FileInf In fileArray
            dtrRow = DupesDb.NewRow
            dtrRow("cFileName") = FileInf.Name
            dtrRow("cExt") = FileInf.Extension
            dtrRow("cSize") = FileInf.Length
            dtrRow("cDateTime") = FileInf.LastWriteTime
            dtrRow("cFullPath") = FileInf.FullName
            DupesDb.Rows.Add(dtrRow)
        Next

        DataGridView1.DataSource = DupesDb
        DataGridView1.Refresh()
    End Sub

    Private Sub btn_LoadImages_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_LoadImages.Click
        Dim r As Integer
        For r = 0 To DupesDb.Rows.Count - 1
            Select Case DupesDb.Rows(r).Item("cExt").ToString.ToLower
                Case ".jpg", ".jpeg", ".png", ".tif", ".tiff", ".wmf", ".bmp", ".gif"
                    Try
                        Dim Img As Image = System.Drawing.Image.FromFile(DupesDb.Rows(r).Item("cFullPath"))
                        If Img.Height > 60 Or Img.Width > 60 Then
                            DupesDb.Rows(r).Item("cThumb") = Img.GetThumbnailImage(60, 60, Nothing, Nothing)
                        Else
                            DupesDb.Rows(r).Item("cThumb") = Img
                        End If

                        Img.Dispose()
                        DataGridView1.Rows(r).Height = 60
                    Catch ex As Exception
                    End Try
                Case ".ico"
                    Try
                        Dim img As New Icon(DupesDb.Rows(r).Item("cFullPath").ToString)
                        DupesDb.Rows(r).Item("cThumb") = img.ToBitmap
                        img.Dispose()
                        DataGridView1.Rows(r).Height = 60
                    Catch ex As Exception
                    End Try
                Case Else
                    DupesDb.Rows(r).Item("cThumb") = CreateBoxImg(Color.White, 1)
            End Select
        Next

        DataGridView1.Refresh()
    End Sub

    Private Sub btn_Load1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Load1.Click
        Dim r As Integer
        For r = 0 To DupesDb.Rows.Count - 1
            Select Case DupesDb.Rows(r).Item("cExt").ToString.ToLower
                Case ".jpg", ".jpeg", ".png", ".tif", ".tiff", ".wmf", ".bmp", ".gif"
                    Try
                        Dim Img As Image = System.Drawing.Image.FromFile(DupesDb.Rows(r).Item("cFullPath"))
                        If Img.Height > 60 Or Img.Width > 60 Then
                            DupesDb.Rows(r).Item("cThumb") = Img.GetThumbnailImage(60, 60, Nothing, Nothing)
                        Else
                            DupesDb.Rows(r).Item("cThumb") = Img
                        End If
                        'Img.Dispose()
                        DataGridView1.Rows(r).Height = 60
                    Catch ex As Exception
                    End Try
                Case ".ico"
                    Try
                        Dim img As New Icon(DupesDb.Rows(r).Item("cFullPath").ToString)
                        DupesDb.Rows(r).Item("cThumb") = img.ToBitmap
                        'img.Dispose()
                        DataGridView1.Rows(r).Height = 60
                    Catch ex As Exception
                    End Try
                Case Else
                    DupesDb.Rows(r).Item("cThumb") = CreateBoxImg(Color.White, 1)
            End Select
        Next

        DataGridView1.Refresh()
    End Sub

    Private Sub tbn_Rename_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tbn_Rename.Click
        Dim oName As String = "C:\ImgTest\Images\busy.gif"
        Dim nName As String = "C:\ImgTest\Images\busy123.gif"

        Try
            Rename(oName, nName)
            MsgBox("Rename Success")
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub btn_Restart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Restart.Click
        DupesDb.Clear()
        Dim oName As String = "C:\ImgTest\Images\busy123.gif"
        Dim nName As String = "C:\ImgTest\Images\busy.gif"
        Try
            Rename(oName, nName)
        Catch ex As Exception
        End Try
    End Sub
End Class